unit Caesar2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, Info, HilfeRegeln;

type
  TCaesar = class(TForm)
    LabelAnzeige: TLabel;
    LabelUeberschrift: TLabel;
    LabelOriginal: TLabel;
    DateiLesen: TOpenDialog;
    DateiSpeichern: TSaveDialog;
    Ausgabe: TMemo;
    Eingabe: TMemo;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    N1: TMenuItem;
    Ende: TMenuItem;
    Codierungsart: TMenuItem;
    Verschluesseln: TMenuItem;
    entschluesseln: TMenuItem;
    StandardNormal: TMenuItem;
    ErweitertNormal: TMenuItem;
    Start: TMenuItem;
    Schluessel: TMenuItem;
    generieren: TMenuItem;
    SWLaden: TMenuItem;
    SchluesselWort: TMemo;
    SwSpeichern: TMenuItem;
    Neu: TMenuItem;
    StandardZufall: TMenuItem;
    ErweitertZufall: TMenuItem;
    Hilfe: TMenuItem;
    Tips: TMenuItem;
    N2: TMenuItem;
    Info1: TMenuItem;
    SWB: TMenuItem;
    procedure EndeClick(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure LadenClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure VerschluesselnClick(Sender: TObject);
    procedure EntschluesselnClick(Sender: TObject);
    procedure SWLadenClick(Sender: TObject);
    procedure SwSpeichernClick(Sender: TObject);
    procedure GenerierenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Zufall;
    procedure StandardNormalClick(Sender: TObject);
    procedure ErweitertNormalClick(Sender: TObject);
    procedure StandardZufallClick(Sender: TObject);
    procedure ErweitertZufallClick(Sender: TObject);
    procedure NeuClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TipsClick(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure SWBClick(Sender: TObject);
  private
    AlphabetAussen,AlphabetInnen,ZufallsStart:String;
  public
    { Public-Deklarationen }
  end;

var
  Caesar: TCaesar;

implementation

{$R *.DFM}

 procedure TCaesar.EndeClick(Sender: TObject);
  begin close end;

 procedure TCaesar.StartClick(Sender: TObject);
  var k,L,ks,le,ls,wo,wo_s,LA:Integer;
      Zeile,schluessel,buchstabe,sbuchstabe,neu,geheim,AlfaAussen,AlfaInnen,AlfaSchluessel:string;
  begin
   if Eingabe.Lines.Count=0 then
    begin
     MessageDlg('Es gibt nichts zu verarbeiten!',mtInformation,[mbOk],0);
     exit
    end;
   schluessel:='';
   for K:=0 to schluesselwort.Lines.Count-1 do
    schluessel:=schluessel+schluesselwort.Lines[K];
   ls:=length(schluessel);
   if ls=0 then
    begin
     MessageBox(0,'Du hast kein Schlsselwort eingegeben!','Eingabefehler',16);
     Exit
    end;
   ks:=0;Ausgabe.Lines.Clear;LA:=Length(AlphabetAussen);
   AlfaAussen:=AlphabetAussen+AlphabetAussen;
   AlfaInnen:=AlphabetInnen+AlphabetInnen;
   for L:=0 to Eingabe.Lines.Count-1 do
    begin
     Zeile:=Eingabe.Lines[L];le:=length(Zeile);geheim:='';
     for k:=1 to le do
      begin
       buchstabe:=copy(Zeile,k,1);
       wo:=pos(buchstabe,AlphabetAussen);
       if wo>0 then
        begin
         inc(ks);if ks>ls then ks:=1;
         sbuchstabe:=copy(schluessel,ks,1);
         wo_s:=pos(sbuchstabe,AlfaInnen); // Position des Schlsselbuchstaben
         AlfaSchluessel:=copy(AlfaInnen,wo_s,La); // Schlsselalfabet
         if Verschluesseln.Checked then neu:=copy(AlfaSchluessel,wo,1)
         else
          begin
           wo:=pos(buchstabe,AlfaSchluessel);
           neu:=copy(AlfaAussen,wo,1);
          end;
         geheim:=geheim+neu
        end
       else geheim:=geheim+buchstabe
      end;
     Ausgabe.Lines.Add(geheim)
    end;
   if StandardZufall.Checked then Ausgabe.Lines.Add(ZufallsStart)
  end;

 procedure TCaesar.LadenClick(Sender: TObject);
  begin
   ForceCurrentDirectory:=True;
   with DateiLesen do
    begin
     Filter:='TextDateien (*.txt)|*.txt|SchlsselDateien (*.swd)|*.swd |Code-Dateien (*.cod)|*.cod|Alle (*.*)|*.*';
     DefaultExt:='pas';
     if Execute then Eingabe.Lines.LoadFromFile(filename)
     else
      begin
       MessageDlg('Es wurde keine Datei gewhlt!',mtError,[mbOk],0);
       exit
      end;
    end;
  end;

 procedure TCaesar.SpeichernClick(Sender: TObject);
  begin
   if Ausgabe.Lines.Count=0 then
    begin
     MessageDlg('Keine Daten!',mtConfirmation,[mbOk],0);
     exit
    end;
   ForceCurrentDirectory:=True;
   with DateiSpeichern do
    begin
     Filter:='Code-Dateien (*.cod)|*.cod';
     Options:=[ofOverwritePrompt];
     DefaultExt:='cod';
     if Execute then Ausgabe.Lines.SaveToFile(Filename)
     else MessageDlg('Die Datei wurde nicht gespeichert!',mtWarning,[mbOk],0);
    end;
  end;

 procedure TCaesar.VerschluesselnClick(Sender: TObject);
  begin
   Verschluesseln.Checked:=True;
   LabelAnzeige.Caption:='verschlsselte Datei';
   LabelAnzeige.Font.Color:=clRed
  end;

 procedure TCaesar.EntschluesselnClick(Sender: TObject);
  begin
   Entschluesseln.Checked:=True;
   LabelAnzeige.Caption:='entschlsselte Datei';
   LabelAnzeige.Font.Color:=clLime
  end;

 procedure TCaesar.Zufall;
  var Zeile,Zeile2:String;
      Ok:Boolean;
      LA,K,wo:Integer;
  begin
   ZufallsStart:='-500';
   Ok:=InputQuery('Zufallsalfabet','Gib die Startzahl ein',ZufallsStart);
   if Not Ok then ZufallsStart:='4711';
   RandSeed:=StrToInt(ZufallsStart);
   if StandardZufall.Checked then Zeile:='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
   else
    begin
     Zeile:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
     Zeile:=Zeile+'abcdefghijklmnopqrstuvwxyz@+*~#<>|,;.:-_';
     Zeile:=Zeile+'0123456789 !"$%&/()=?{[]}\'+'''';
    end;
   Zeile2:=Zeile;
   LA:=Length(Zeile);
   AlphabetAussen:='';
   for K:=1 to LA do
    begin
     repeat
      wo:=random(LA)+1;
     until Zeile[wo]<>#0;
     AlphabetAussen:=AlphabetAussen+Zeile[wo];
     Zeile[wo]:=#0;
    end;
   AlphabetInnen:='';
   for K:=1 to LA do
    begin
     repeat
      wo:=random(LA)+1;
     until Zeile2[wo]<>#0;
     AlphabetInnen:=AlphabetInnen+Zeile2[wo];
     Zeile2[wo]:=#0;
    end;
   ShowMessage(AlphabetAussen+#13+AlphabetInnen);
  end;

 procedure TCaesar.SWLadenClick(Sender: TObject);
  begin
   ForceCurrentDirectory:=True;
   with DateiLesen do
    begin
     Filter:='SchlsselDateien (*.swd) | *.swd';
     DefaultExt:='swd';
     if Execute then SchluesselWort.Lines.LoadFromFile(filename)
     else
      begin
       MessageDlg('Es wurde keine Datei gewhlt!',mtError,[mbOk],0);
       exit
      end;
    end;
  end;

 procedure TCaesar.SwSpeichernClick(Sender: TObject);
  begin
   if SchluesselWort.Lines.Count=0 then
    begin
     MessageDlg('Keine Daten!',mtConfirmation,[mbOk],0);
     exit
    end;
   ForceCurrentDirectory:=True;
   with DateiSpeichern do
    begin
     Filter:='SchlsselDateien (*.swd)|*.swd';
     Options:=[ofOverwritePrompt];
     DefaultExt:='swd';
     if Execute then SchluesselWort.Lines.SaveToFile(Filename)
     else MessageDlg('Die Datei wurde nicht gespeichert!',mtWarning,[mbOk],0);
    end;
  end;

 procedure TCaesar.GenerierenClick(Sender: TObject);
  var ZufallsEingabe,SW:String;
      K:Integer;
      Ok:Boolean;
  begin
   SW:='';ZufallsEingabe:='100';
   Ok:=InputQuery('Zufallsschlssel','Gib die Lnge ein',ZufallsEingabe);
   if Not Ok then ZufallsEingabe:='4711';
   for K:=1 to StrToInt(ZufallsEingabe) do SW:=SW+AlphabetAussen[Random(Length(AlphabetAussen))+1];
   Schluesselwort.Clear;
   Schluesselwort.Lines.Add(SW);
  end;

 procedure TCaesar.FormCreate(Sender: TObject);
  begin
   Randomize;StandardNormal.Checked:=True;
   AlphabetAussen:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   AlphabetInnen:=AlphabetAussen;
  end;

 procedure TCaesar.StandardNormalClick(Sender: TObject);
  begin
   StandardNormal.Checked:=True;
   AlphabetAussen:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   AlphabetInnen:=AlphabetAussen;
  end;

 procedure TCaesar.StandardZufallClick(Sender: TObject);
  begin
   StandardZufall.Checked:=True;
   Zufall;
  end;

 procedure TCaesar.ErweitertNormalClick(Sender: TObject);
  begin
   ErweitertNormal.Checked:=True;
   AlphabetAussen:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   AlphabetAussen:=AlphabetAussen+'abcdefghijklmnopqrstuvwxyz@+*~#<>|,;.:-_';
   AlphabetAussen:=AlphabetAussen+'0123456789 !"$%&/()=?{[]}\'+'''';
   AlphabetInnen:=AlphabetAussen;
  end;

 procedure TCaesar.ErweitertZufallClick(Sender: TObject);
  begin
   ErweitertZufall.Checked:=True;
   Zufall;
  end;

 procedure TCaesar.NeuClick(Sender: TObject);
  begin SchluesselWort.Clear end;

 procedure TCaesar.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   if MessageDlg('Willst du wirklich beenden?',
                  mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Herr Vigenre verabschiedet sich.', mtInformation,[mbOk], 0);
     CanClose:=True;
    end
   else CanClose:=False;
  end;

 procedure TCaesar.TipsClick(Sender: TObject);
  begin
   RegelnBox.ShowModal;
  end;

 procedure TCaesar.Info1Click(Sender: TObject);
  begin
   InfoBox.ShowModal;
  end;

 procedure TCaesar.SWBClick(Sender: TObject);
  var EZeile,AZeile,Schluessel,Buchstabe,Sbuchstabe,AlfaAussen,AlfaInnen:String;
      LA,K,L,LEin,LAus,wo,woneu,wo_s:Integer;
  begin
   if Eingabe.Lines.Count=0 then
    begin
     MessageDlg('Es gibt nichts zu verarbeiten!',mtInformation,[mbOk],0);
     exit
    end;
   if Ausgabe.Lines.Count=0 then
    begin
     MessageDlg('Es gibt nichts zu verarbeiten!',mtInformation,[mbOk],0);
     exit
    end;
   EZeile:='';
   for L:=0 to Eingabe.Lines.Count-1 do EZeile:=EZeile+Eingabe.Lines[L];
   LEin:=length(EZeile);
   AZeile:='';
   for L:=0 to Ausgabe.Lines.Count-1 do AZeile:=AZeile+Ausgabe.Lines[L];
   LAus:=length(AZeile);
   if LAus<>LEin then
    begin
     MessageDlg('Ein- und Ausgabe sind verschieden lang!',mtInformation,[mbOk],0);
     exit
    end;
   schluessel:='';
   LA:=Length(AlphabetAussen);
   AlfaAussen:=AlphabetAussen+AlphabetAussen;
   AlfaInnen:=AlphabetInnen+AlphabetInnen;
   for K:=1 to LEin do
    begin
     buchstabe:=copy(EZeile,K,1);
     wo:=pos(buchstabe,AlfaAussen);
     if wo>0 then
      begin
       sbuchstabe:=copy(AZeile,K,1);
       wo_s:=pos(sbuchstabe,AlfaInnen); // Position des Codebuchstaben
       woneu:=LA+wo_s-wo+1;
       schluessel:=schluessel+copy(AlfaInnen,woneu,1);
      end
     else schluessel:=schluessel+buchstabe
    end;
   SchluesselWort.Clear;
   SchluesselWort.Lines.Add(schluessel);
  end;

end.

